var runingid ;
var showingPoplayerUrl='';
var showingTouchUrl='';
var spFileName='DACU_HUICHANG_1';
var spKey='DACU_HUICHANG_1_INDEX';
var isInit=false;
var bean;
var baseinfo;
var isBegin=false;
var pageMap;
var isRunning=false;
var touchIndex=0;



function init(params,platform){
      bean = JSON.parse(params);
      baseinfo = JSON.parse(platform);
      runingid = bean.id;
      pageMap = new HashMap();
      __nativeLog__("大促会场任务1",runingid);
      readTouchFile(spFileName, spKey);
}


function destroy() {

}

function onMessage(scene,trigger,params){

    var paramsobj = JSON.parse(params);
    var action = paramsobj.actionName;
    var flowId = bean.statusId;
    var bizCode = bean.bizCode;
    var taskStatus = paramsobj.taskStatus;
    var preSceneName = paramsobj.preSceneName;

    __nativeLog__("大促会场任务1", "preSceneName : " + preSceneName + "  taskStatus: " + taskStatus);

    var url1 = "";

    if(scene  ==  'Page_Dacu'  &&  trigger  ==  'enter' && action == 'Page_Dacu'){

        if(touchIndex == 0){
            url1 = "https://cybert.m.1688.com/test/index.html?sceneName=chimera_10697&params=industry_all5_now0";
        }
        if(touchIndex == 1){
            url1 = "https://cybert.m.1688.com/test/index.html?sceneName=chimera_10697&params=industry_all5_now1";
        }
        if(touchIndex == 2){
            url1 = "https://cybert.m.1688.com/test/index.html?sceneName=chimera_10697&params=industry_all5_now2";
        }
        if(touchIndex == 3){
            url1 = "https://cybert.m.1688.com/test/index.html?sceneName=chimera_10697&params=industry_all5_now3";
        }
        if(touchIndex == 4){
            url1 = "https://cybert.m.1688.com/test/index.html?sceneName=chimera_10697&params=industry_all5_now4";
        }

        if(!isEmpty(url1)){
            //弹出底部浮条
            showingTouchUrl = url1;
            __nativeLog__("大促会场任务1", "浮条url ： " + showingTouchUrl + " touchIndex : " + touchIndex );
            showTouch(showingTouchUrl);
        }
    }

    if(scene  ==  'Page_Detail'  &&  trigger  ==  'enter' && action == 'Page_Detail' && preSceneName == 'Page_Dacu'){
        touchIndex++;
        saveCurrentIndex(touchIndex);

        if(touchIndex == 5){
            showingPoplayerUrl = 'https://cybert.m.1688.com/ulx05f7l.html?sceneName=chimera_18435&poplayerType=cyberT';
            showPopLayer(showingPoplayerUrl);
            setLastEvent(scene, trigger, params);
            finishCurrent();
        }
    }

}




function saveCurrentIndex(index){
     __nativeLog__("大促会场任务1","存储num：" + index);
    var params = {
        File: spFileName,
        key: spKey,
        value: index
    };
    var paramsStr = JSON.stringify(params);
    __nativeLog__("大促会场任务1","params" + paramsStr);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__("大促会场任务1","写入成功：" + data);
        },function(err){
            __nativeLog__("fail",err);
        });
}

function readTouchFile(file,key){
    var params = {
        File: file,
        key: key
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__("大促会场任务1","读取的data： " + data);
        var json = JSON.parse(data);
        var dataStr = json.data.data;
        if( typeof dataStr == "undefined" || dataStr == null || dataStr == ""){
            //初始情况下，执行第一个任务
            touchIndex = 0;
        }else{
            touchIndex = parseInt(dataStr);
            //调试用
            isInit=false;
        }
        __nativeLog__("大促会场任务1","touchIndex： " + currentIndex);
    },function(err){
        __nativeLog__("fail",err);
    });
}


function getPopUrl(url){
    var queryType = bean.actionParam.queryType;
    var queryParam = bean.actionParam.queryParam;

    __nativeLog__("大促会场任务1","queryType:" + queryType + "queryParam:" + queryParam);

     var resultUrl = url + "&useLaunchExtendQueryMode=true" + "&launchQueryType=" + queryType + "&launchQueryParam=" + queryParam + "&taskId=" + runingid + "&statusId=" + bean.statusId;

    __nativeLog__("大促会场任务1",JSON.stringify(resultUrl));
    return resultUrl;
}

function setLastEvent(scene,trigger,params) {
    var params = {
        id: runingid,
        scene:scene,
        trigger:trigger,
        params:params
    };
    WVBridge("UIWvApiPlugin","lastEvent",params,function(data){
        __nativeLog__("大促会场任务1","上个event：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function updateInfo(bean,scene,trigger,action,eventparams,status) {
    var benstr = JSON.stringify(bean);
    var event = {
            sceneName: scene,
            triggerName:trigger,
            actionName:action
        };
    var eventstr = JSON.stringify(event);
    var params = {
        id: runingid,
        bean: benstr,
        event:eventstr,
        eventparams:eventparams,
        status:status
    };
    WVBridge("UIWvApiPlugin","updateInfo",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}


function closeCurrentPop(){
     if(!isEmpty(showingPoplayerUrl)){
         closeTouch(showingPoplayerUrl);
      }
}

function closeCurrentTouch(){
    if(!isEmpty(showingTouchUrl)){
        closeTouch(showingTouchUrl);
     }
}


function isEmpty(obj){
    if(typeof obj == "undefined" || obj == null || obj == ""){
        return true;
    }else{
        return false;
    }
}


function finishCurrent() {
    var params = {
        id: runingid
    };
    WVBridge("UIWvApiPlugin","finishCurrent",params,function(data){
        __nativeLog__("大促会场任务1","结束当前节点" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}



function showPopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showPoplayer",params,function(data){
        __nativeLog__("大促会场任务1","显示poplayer：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function showPopLayer(url, func) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showPoplayer",params,func);
}

function showTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showTouch",params,function(data){
        __nativeLog__("大促会场任务1","展示Touch：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function saveOfferNum(num){
    __nativeLog__("大促会场任务1","存储num：" + num);
    var params = {
        File: spFileName,
        key: spKey,
        value: num
    };
    __nativeLog__("大促会场任务1","params" + params);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__("大促会场任务1","写入成功：" + data);
        },function(err){
            __nativeLog__("fail",err);
        });
}

function readOfferNum(){
    var params = {
        File: spFileName,
        key: spKey
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__("大促会场任务1","读取的data： " + data);
        var json = JSON.parse(data);
        offernum = parseInt(json.data.data);
        __nativeLog__("大促会场任务1","读取的num： " + offernum);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closePopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closePoplayer",params,function(data){
        __nativeLog__("大促会场任务1",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closeTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closeTouch",params,function(data){
        __nativeLog__("大促会场任务1",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}


function HashMap(){
    var length = 0;
    var obj = new Object();

    this.isEmpty = function(){
        return length == 0;
    };

    this.containsKey=function(key){
        return (key in obj);
    };

    this.containsValue=function(value){
        for(var key in obj){
            if(obj[key] == value){
                return true;
            }
        }
        return false;
    };

    this.put=function(key,value){
        if(!this.containsKey(key)){
            length++;
        }
        obj[key] = value;
    };

    this.get=function(key){
        return this.containsKey(key)?obj[key]:null;
    };

    this.remove=function(key){
        if(this.containsKey(key)&&(delete obj[key])){
            length--;
        }
    };

    this.values=function(){
        var _values= new Array();
        for(var key in obj){
            _values.push(obj[key]);
        }
        return _values;
    };

    this.keySet=function(){
        var _keys = new Array();
        for(var key in obj){
            _keys.push(key);
        }
        return _keys;
    };

    this.size = function(){
        return length;
    };

    this.clear = function(){
        length = 0;
        obj = new Object();
    };
}

