var runingid ;
var showingPoplayerUrl='';
var showingTouchUrl='';
var spFileName='DACU_RECOMMEND_1';
var spKey='DACU_RECOMMEND_1_INDEX';
var isInit=false;
var bean;
var baseinfo;
var isBegin=false;
var pageMap;
var isRunning=false;
var touchIndex=0;
var taskStatus='';
var tag = "大促为你推荐引导";
var totalNumber=5;
var hasShow=false;//浮条是否已经激活




function init(params,platform){
      bean = JSON.parse(params);
      baseinfo = JSON.parse(platform);
      runingid = bean.id;
      taskStatus = bean.taskStatus;
      pageMap = new HashMap();
      __nativeLog__(tag," runningid: " + runingid + "  taskStatus:  " + taskStatus);

      if(taskStatus == 'NO_START'){
        touchIndex = 0;
        saveCurrentIndex(touchIndex);
      }

      if(taskStatus == 'RUNNING'){
        readTouchFile(spFileName, spKey);
      }

      var extParams = bean.actionParam;
      totalNumber = extParams.totalNumber;
}


function destroy() {

}

function onMessage(scene,trigger,params){

    var paramsobj = JSON.parse(params);
    var action = paramsobj.actionName;
    var flowId = bean.statusId;
    var bizCode = bean.bizCode;
    var taskStatus = paramsobj.taskStatus;
    var preSceneName = paramsobj.preSceneName;

    updateInfo(bean,scene,trigger,action,params,'begin');

    __nativeLog__(tag, "preSceneName : " + preSceneName + "  taskStatus: " + taskStatus + " touchIndex: " + touchIndex);


    if(scene == 'Page_Home' && trigger == 'leave'){//离开首页fragment, 关闭现有渲染浮条
        closeCurrentTouch();
    }

    var url1 = "";

    //在首页进行了任何点击，都将closeCurrent
    if(trigger == 'click' && scene == 'Page_Home' && action != 'GuessTab'){//兼容安卓端的一个bug 推荐tab 出现前会有一次推荐tab的点击
        hasClick=true;
        closeCurrentTouch();
    }

    // 返回到Home时继续引导
    if((scene  ==  'V7HomePage'  &&  trigger  ==  'back' && action == 'V7HomePage') ||
       (scene  ==  'Page_Home'  &&  trigger  ==  'back' && action == 'Page_Home' && baseinfo.os == 'ios')){

        closeCurrentTouch();

        url1 = "https://cybert.m.1688.com/test/index.html?sceneName=chimera_20236&extParams=";


        if(!isEmpty(url1)){

            __nativeLog__(tag, "浮条url ： " + showingTouchUrl + " touchIndex : " + touchIndex );
            var extParams = bean.actionParam;
            extParams.needClkNum = totalNumber - touchIndex;
            extParams.currentIndex = touchIndex;
            showingTouchUrl = url1 + JSON.stringify(extParams);
            showTouch(showingTouchUrl);
        }

    }

    //从首页进入OD时引导
    if((scene  ==  'Page_Detail'  &&  trigger  ==  'enter' && action == 'Page_Detail' && preSceneName == 'Page_Home')
    ){
        closeCurrentTouch();
        touchIndex++;
        saveCurrentIndex(touchIndex);

        url1 = "https://cybert.m.1688.com/test/index.html?sceneName=chimera_18839&extParams=";


            //进行最后一次引导后进入会场
            if(touchIndex >= totalNumber){
                //引导完成
                __nativeLog__(tag, "引导完成");

                updateInfo(bean,scene,trigger,action,params,'end');

                setLastEvent(scene,trigger,params)
                finishCurrent();
                __nativeLog__(tag, "finish");
            }

            if(!isEmpty(url1)){
                //弹出底部浮条
                __nativeLog__(tag, "浮条url ： " + showingTouchUrl + " touchIndex : " + touchIndex );
                var extParams = bean.actionParam;
                extParams.needClkNum = totalNumber - touchIndex;
                extParams.currentIndex = touchIndex;
                showingTouchUrl = url1 + JSON.stringify(extParams);
                showTouch(showingTouchUrl);
            }

    }

}




function saveCurrentIndex(index){
     __nativeLog__(tag,"存储num：" + index);
    var params = {
        File: spFileName,
        key: spKey,
        value: index
    };
    var paramsStr = JSON.stringify(params);
    __nativeLog__(tag,"params" + paramsStr);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__(tag,"写入成功：" + data);
        },function(err){
            __nativeLog__("fail",err);
        });
}

function readTouchFile(file,key){
    var params = {
        File: file,
        key: key
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
         var dataStr = "";
         __nativeLog__(tag,"读取的data： " + data);
         __nativeLog__(tag,"读取的baseinfo： " + baseinfo.os);
         if(baseinfo.os == "ios"){
             __nativeLog__(tag,"读取的data： " + JSON.stringify(data));
             dataStr = data.data.data;
         }else{
            var json = JSON.parse(data);
            dataStr = json.data.data;
         }
        if( typeof dataStr == "undefined" || dataStr == null || dataStr == ""){
            //初始情况下，执行第一个任务
            touchIndex = 0;
        }else{
            touchIndex = parseInt(dataStr);
            //调试用
            isInit=false;
        }
        __nativeLog__(tag,"touchIndex： " + touchIndex);
    },function(err){
        __nativeLog__("fail",err);
    });
}


function getPopUrl(url){
    var queryType = bean.actionParam.queryType;
    var queryParam = bean.actionParam.queryParam;

    __nativeLog__(tag,"queryType:" + queryType + "queryParam:" + queryParam);

     var resultUrl = url + "&useLaunchExtendQueryMode=true" + "&launchQueryType=" + queryType + "&launchQueryParam=" + queryParam + "&taskId=" + runingid + "&statusId=" + bean.statusId;

    __nativeLog__(tag,JSON.stringify(resultUrl));
    return resultUrl;
}

function setLastEvent(scene,trigger,params) {
    var params = {
        id: runingid,
        scene:scene,
        trigger:trigger,
        params:params
    };
    WVBridge("UIWvApiPlugin","lastEvent",params,function(data){
        __nativeLog__(tag,"上个event：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function updateInfo(bean,scene,trigger,action,eventparams,status) {
    var benstr = JSON.stringify(bean);
    var event = {
            sceneName: scene,
            triggerName:trigger,
            actionName:action
        };
    var eventstr = JSON.stringify(event);
    var params = {
        id: runingid,
        bean: benstr,
        event:eventstr,
        eventparams:eventparams,
        status:status
    };
    WVBridge("UIWvApiPlugin","updateInfo",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}


function closeCurrentPop(){
     if(!isEmpty(showingPoplayerUrl)){
         closeTouch(showingPoplayerUrl);
      }
}

function closeCurrentTouch(){
    if(!isEmpty(showingTouchUrl)){
        closeTouch(showingTouchUrl);
     }
}


function isEmpty(obj){
    if(typeof obj == "undefined" || obj == null || obj == ""){
        return true;
    }else{
        return false;
    }
}


function finishCurrent() {
    var params = {
        id: runingid
    };
    WVBridge("UIWvApiPlugin","finishCurrent",params,function(data){
        __nativeLog__(tag,"结束当前节点" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}



function showPopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showPoplayer",params,function(data){
        __nativeLog__(tag,"显示poplayer：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function showPopLayer(url, func) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showPoplayer",params,func);
}

function showTouch(url) {
    showingTouchUrl = url + "&processId=" + bean.statusId + "&nodeId=" + bean.id;

    var params = {
        url: showingTouchUrl,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showTouch",params,function(data){
        __nativeLog__(tag,"展示Touch：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function saveOfferNum(num){
    __nativeLog__(tag,"存储num：" + num);
    var params = {
        File: spFileName,
        key: spKey,
        value: num
    };
    __nativeLog__(tag,"params" + params);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__(tag,"写入成功：" + data);
        },function(err){
            __nativeLog__("fail",err);
        });
}

function readOfferNum(){
    var params = {
        File: spFileName,
        key: spKey
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__(tag,"读取的data： " + data);
        var json = JSON.parse(data);
        offernum = parseInt(json.data.data);
        __nativeLog__(tag,"读取的num： " + offernum);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closePopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closePoplayer",params,function(data){
        __nativeLog__(tag,data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closeTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closeTouch",params,function(data){
        __nativeLog__(tag,data);
    },function(err){
        __nativeLog__("fail",err);
    });
}


function HashMap(){
    var length = 0;
    var obj = new Object();

    this.isEmpty = function(){
        return length == 0;
    };

    this.containsKey=function(key){
        return (key in obj);
    };

    this.containsValue=function(value){
        for(var key in obj){
            if(obj[key] == value){
                return true;
            }
        }
        return false;
    };

    this.put=function(key,value){
        if(!this.containsKey(key)){
            length++;
        }
        obj[key] = value;
    };

    this.get=function(key){
        return this.containsKey(key)?obj[key]:null;
    };

    this.remove=function(key){
        if(this.containsKey(key)&&(delete obj[key])){
            length--;
        }
    };

    this.values=function(){
        var _values= new Array();
        for(var key in obj){
            _values.push(obj[key]);
        }
        return _values;
    };

    this.keySet=function(){
        var _keys = new Array();
        for(var key in obj){
            _keys.push(key);
        }
        return _keys;
    };

    this.size = function(){
        return length;
    };

    this.clear = function(){
        length = 0;
        obj = new Object();
    };
}

