var runingid ;
var showingPoplayerUrl='';
var showingTouchUrl='';
var spFileName='INDUSTRIES_DUTY_LIVE';
var spKey='INDUSTRIES_CURRENT_INDEX_LIVE';
var touchKey = 'TOUCH_INDEX_LIVE';
var spFatigueKey='FATIGUE_KEY'
var startTime=0;
var validTime=0;
var resetTime=0;
var isFinished=false;
var isPass=false;
var isReset=false;
//是否从新人承接页过来的
var isInPage = false;
var isInit=false;
var bean;
var baseinfo;
var isBegin=false;
var isInHome;
var pageMap;
var isRunning=false;
var currentIndex=1;
var oneDayTime = 86400000;
var touchIndex = 0;



function init(params,platform){
      bean = JSON.parse(params);
      baseinfo = JSON.parse(platform);
      runingid = bean.id;
      pageMap = new HashMap();
      __nativeLog__("工业品直播任务",runingid);
      readSpFile(spFileName,spKey);
      readTouchFile(spFileName,touchKey);
}


function destroy() {

}

function onMessage(scene,trigger,params){

    var paramsobj = JSON.parse(params);
    var action = paramsobj.actionName;
    var flowId = bean.statusId;
    var bizCode = bean.bizCode;


    var gypUrl = paramsobj.URL;
    if(isEmpty(gypUrl)){//兼容IOS
        gypUrl = paramsobj.url;
    }
    __nativeLog__("工业品直播任务", "gypUrl : " + gypUrl);

//    //调试用，每次都重新开始任务
//    if(!isInit){
//        currentIndex = 1;
//        touchIndex = 0;
//        isInit=true;
//        __nativeLog__("工业品直播任务", "init  : " + "currentIndex :" + currentIndex + "  touchIndex: " + touchIndex);
//    }

    //直播间判断 是否从工业品直播站 跳转过来
    if(((gypUrl || '').indexOf('__qll_scene__=gyp') != -1)  // 直播会场
    ) {
        isInPage = true;
    }else{
        isInPage = false;
    }



    //进入了工业品直播站
    if(scene  ==  'Page_industries_live'  &&  trigger  ==  'expose' && action == 'weexTitleAppear'){  // 该方式有待商榷
        pageMap.put(scene,true);
    }

    if(scene  ==  'Page_industries_live'  &&  trigger  ==  'enter' && action == 'Page_industries_live'){  // 该方式有待商榷
        pageMap.put(scene,true);
    }

    //离开了工业品直播站
    if(scene  ==  'Page_industries_live'  &&  trigger  ==  'leave'){
        pageMap.remove(scene);
    }


    __nativeLog__("工业品直播任务", "工业品直播任务 " + scene + " trigger : " + trigger + " action : " + action + " isInPage : " + isInPage + " pageMap: " + pageMap.containsKey('Page_蓄水承接页') + " currentIndex : " + currentIndex);

    //触发了任务行动点，执行任务
    if((scene == 'AliPopLayer' && trigger == 'custom' && action == 'weexModuleInvoke.close') ||
       (scene == 'Page_industries_live' && trigger == 'custom' && action == 'alipoplayer_weex_poplayerClose') ||
    (scene == 'Page_industries_live' && trigger == 'expose' && action == 'weexTitleAppear') ||
    (scene == 'Page_industries_live' && trigger == 'custom' && action == 'weexFragmentAppear') ||
       (scene == 'Page_industries_live' && (trigger == 'enter' || trigger == 'back') && action == 'Page_industries_live') ||
    (scene == 'LiveVideo' && trigger == 'enter' && isInPage) ||
       (scene == 'Page_AMLiveAudienceInteractiveVC' && trigger == 'enter' && isInPage)){

            __nativeLog__("工业品直播任务","isInPage : " + isInPage);
            __nativeLog__("工业品直播任务","startTime : " + startTime + " validTime : " + validTime + " resetTime : " + resetTime + " isPass : " + isPass + " isReset : " + isReset);

            getFatigueForCancelFromSP(bizCode,flowId,runingid,scene,trigger,params,action);

    }

}

//从SP中获取疲劳信息的执行方式
function getFatigueForCancelFromSP(bizCode,flowId,processorId,scene,trigger,params,action){
    var bizCodestr = JSON.stringify(bizCode);
    var flowIdstr = JSON.stringify(flowId);
    var processorIdstr = JSON.stringify(processorId);

    __nativeLog__("工业品直播任务","开始执行任务 currentdIndex : " + currentIndex);
    if(currentIndex == 1){
        if((scene  ==  'Page_industries_live'  &&  trigger  ==  'expose' && action == 'weexTitleAppear') ||
           (scene  ==  'Page_industries_live'  &&  trigger  ==  'enter' && action == 'Page_industries_live')){
            //无疲劳，且当前节点为1，触发行动点为任务1的行动点，执行任务1
            taskOne(scene,trigger,params,action);
        }
    }else if(currentIndex == 2){
        if((scene == 'LiveVideo' && trigger == 'enter') || (scene == 'Page_AMLiveAudienceInteractiveVC' && trigger == 'enter')){ //记录看了几个OD
            markOD(scene,trigger,params,action);
            return;
        }

        if((scene == 'AliPopLayer' && trigger == 'custom' && action == 'weexModuleInvoke.close')||
           (scene == 'Page_industries_live' && trigger == 'custom' && action == 'alipoplayer_weex_poplayerClose')){
            //用户是在工业品直播
            if(pageMap.containsKey('Page_industries_live')){ //这里一般都会成立，因为 对应场景的 weexpoplayerclose 后一定已经存在pageMap中了
                //无疲劳，且当前节点为2， 执行任务2
                taskTwo(scene,trigger,params,action);
                return;
            }else{
                __nativeLog__("工业品直播任务", "用户不在工业品直播会场");
            }
        }else{
            //回到页面后的补偿
            if((scene == 'Page_industries_live' && trigger == 'custom' && action == 'weexFragmentAppear') || (scene == 'Page_industries_live' && (trigger == 'enter' || (trigger == 'back')))){
                taskTwo(scene,trigger,params,action);
                return;
            }
        }

    }else if(currentIndex == 3){// 这里基本不会执行到， 兜底吧
        if((scene == 'LiveVideo' && trigger == 'enter') || (scene == 'Page_AMLiveAudienceInteractiveVC' && trigger == 'enter')){
            taskThree(scene,trigger,params,action);
            return;
        }


    }else{//其它的场景， 有疲劳、 节点为4时 不触发任务执行
        __nativeLog__("工业品直播任务", "currentIndex: " + currentIndex + " isPass : " + isRunning);
    }

}

function markOD(scene,trigger,params,action){
    touchIndex++;
        __nativeLog__("工业品直播任务","touchIndex++后  : " + touchIndex);

        closeCurrentTouch();

        __nativeLog__("工业品直播任务","closeCurrentTouch ");


        if(touchIndex == 1){ // index为1时触发任务3。
            currentIndex = 3;
            __nativeLog__("工业品直播任务", "currentIndex = " + currentIndex);
            saveCurrentIndex(3);
            taskThree(scene,trigger,params,action);
        }
}


//第一个任务的执行逻辑, 发updateInfo, 弹红包，设置currentIndex=2 存入本地 发updateInfo
function taskOne(scene,trigger,params,action){
    //上报updateInfo
    __nativeLog__("工业品直播任务", "updateinfo1");
    var paramsStr = JSON.stringify(params);
    updateInfo(bean,scene,trigger,action,paramsStr,'begin');

    //执行任务1
    __nativeLog__("工业品直播任务", "执行任务1");

    var url1 = "https://show.1688.com/yhzz/new/eupeavgm.html?wh_weex=true&cms_id=10955&__weex__=true&__pageId__=10955&useLaunchExtendQueryMode=true&launchQueryType=activityId&launchQueryParam=1337";

    var poplayerUrl1 = url1;
    __nativeLog__("工业品直播任务", "红包url ： " + poplayerUrl1);
    //弹出poplayer
    showPopLayer(poplayerUrl1);

    __nativeLog__("工业品直播任务", "updateinfo1 end");
    updateInfo(bean,scene,trigger,action,paramsStr,'end');

    //设置任务1已执行完， 标记应该执行任务2
    currentIndex = 2;
    __nativeLog__("工业品直播任务", "currentIndex = " + currentIndex);
    saveCurrentIndex(2);
}

//第二个任务的执行逻辑, 发updateInfo, 弹红包，设置currentIndex=3 存入本地 发updateInfo
function taskTwo(scene,trigger,params,action){
    //上报 updateInfo
    __nativeLog__("工业品直播任务", "updateinfo");
    params.currentIndex = currentIndex;
    var paramsStr = JSON.stringify(params);
    updateInfo(bean,scene,trigger,action,paramsStr,'begin');

    //执行任务2
    __nativeLog__("工业品直播任务", "执行任务2  touchIndex: " + touchIndex);


    var url1 = "";

    if(touchIndex == 0){
        url1 = "https://cybert.m.1688.com/test/index.html?sceneName=chimera_10697&params=industry_live";
    }

    if(touchIndex == 1){
        __nativeLog__("工业品直播任务", " touchIndex : " + touchIndex + " 大于临界值，退出不执行");
        return;
    }

    if(!isEmpty(url1)){
        //弹出底部浮条
        showingTouchUrl = url1;
        __nativeLog__("工业品直播任务", "浮条url ： " + showingTouchUrl + " touchIndex : " + touchIndex );
        showTouch(showingTouchUrl);
    }


    if(touchIndex == 1){
            currentIndex = 3;
            __nativeLog__("工业品直播任务", "currentIndex = " + currentIndex);
            saveCurrentIndex(3);
        }
}

//第二个任务的执行逻辑, 发updateInfo, 弹红包，设置currentIndex=3 存入本地 发updateInfo
function taskThree(scene,trigger,params,action){
    //上报 updateInfo
    __nativeLog__("工业品直播任务", "updateinfo");
    params.currentIndex = currentIndex;
    var paramsStr = JSON.stringify(params);
    updateInfo(bean,scene,trigger,action,paramsStr,'begin');

    closeCurrentTouch();

    //获取红包url
    var poplayerUrl2 = "https://show.1688.com/yhzz/new/eupeavgm.html?wh_weex=true&cms_id=10955&__weex__=true&__pageId__=10955&useLaunchExtendQueryMode=true&launchQueryType=activityId&launchQueryParam=1340";

    __nativeLog__("工业品直播任务", "红包url ： " + poplayerUrl2);
    //弹出poplayer
    showPopLayer(poplayerUrl2);

    __nativeLog__("工业品直播任务", "updateinfo end");
    updateInfo(bean,scene,trigger,action,paramsStr,'end');


    //设置任务1已执行完， 标记应该执行任务4 即不用再执行了
    currentIndex = 4;
    __nativeLog__("工业品直播任务", "currentIndex = " + currentIndex);
    saveCurrentIndex(4);

    finishCurrent();
}

function saveCurrentIndex(index){
     __nativeLog__("工业品直播任务","存储num：" + index);
    var params = {
        File: spFileName,
        key: spKey,
        value: index
    };
    var paramsStr = JSON.stringify(params);
    __nativeLog__("工业品直播任务","params" + paramsStr);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__("工业品直播任务","写入成功：" + data);
        },function(err){
            __nativeLog__("fail",err);
        });
}

function readTouchFile(file,key){
    var params = {
        File: file,
        key: key
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__("工业品直播任务","读取的data： " + data);
        var json = JSON.parse(data);
        var dataStr = json.data.data;
        if( typeof dataStr == "undefined" || dataStr == null || dataStr == ""){
            //初始情况下，执行第一个任务
            touchIndex = 0;
        }else{
            touchIndex = parseInt(dataStr);

            //调试用
            isInit=false;
        }
        __nativeLog__("工业品直播任务","touchIndex： " + currentIndex);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function readSpFile(file,key){
    var params = {
        File: file,
        key: key
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__("工业品直播任务","读取的data： " + data);
        var json = JSON.parse(data);
        var dataStr = json.data.data;
        if( typeof dataStr == "undefined" || dataStr == null || dataStr == ""){
            //初始情况下，执行第一个任务
            currentIndex = 1;
        }else{
            currentIndex = parseInt(dataStr);
            //调试用
            isInit=false;
        }
        __nativeLog__("工业品直播任务","currentIndex： " + currentIndex);
    },function(err){
        __nativeLog__("fail",err);
    });
}

//从Mtop获取疲劳度执行方式
function getFatigueForCancelFromMtop(bizCode,flowId,processorId,scene,trigger,params,action){
    var bizCodestr = JSON.stringify(bizCode);
    var flowIdstr = JSON.stringify(flowId);
    var processorIdstr = JSON.stringify(processorId);

    //参数
    var params = {
        bizCode: bizCodestr,
        flowId: flowIdstr,
        processorId: processorIdstr
    }

    //mtop
    WVBridge("MtopWVPlugin","send",{
            api:'mtop.taobao.widgetService.getJsonComponentRequireLogin',
            v:'2.0',
            param:{
                cid:'getFatigueRule:getFatigueRule',
                methodName:'execute',
                params:JSON.stringify(params)
            },
            ecode:0
        },(resJson) => {
            __nativeLog__("工业品直播任务",resJson);
            var result = JSON.parse(resJson);
            //判断是否reset
            if(result && result.data && result.data.rstModel && result.data.rstModel.result &&
            result.data.rstModel.result.reset){
                //整个任务执行完后，就不用再次执行该任务了
                if(currentIndex == 3){
                    return;
                }
                var isReset = result.data.rstModel.result.reset;
                __nativeLog__("工业品直播任务", "isReset: " + isReset);
                currentIndex = 1;
                __nativeLog__("工业品直播任务", "重新设置currentIndex 并存至本地 " + isReset);
                saveCurrentIndex(1);
                //需要reset，执行任务1
                taskOne(scene,trigger,params,action);
                __nativeLog__("工业品直播任务", "excute task 1");
            }else{
                //不需要reset
                var isReset = result.data.rstModel.result.reset;
                __nativeLog__("工业品直播任务", "isReset: " + isReset);
                isRunning = result.data.rstModel.result.pass;
                if(currentIndex == 1 && isRunning){
                    if(scene == 'Page_蓄水承接页' && trigger == 'enter'){
                        //无疲劳，且当前节点为1，触发行动点为任务1的行动点，执行任务1
                        taskOne(scene,trigger,params,action);
                    }
                }else if(currentIndex == 2 && isRunning){
                    if(scene == 'Page_Detail' && trigger == 'enter'){
                        //用户是从新人承接页进入的OD
                        if(pageMap.containsKey('Page_蓄水承接页') || pageMap.containsKey('蓄水承接页')){
                            //无疲劳，且当前节点为2， 执行任务2
                            taskTwo(scene,trigger,params,action);
                        }else{
                            __nativeLog__("工业品直播任务", "用户并非从新人承接页进入的OD");
                        }
                    }
                }//其它的场景， 有疲劳、 节点为3时 不触发任务执行
            }
        },(resJson) =>{
            isRunning=false;
            __nativeLog__("fail",resJson);
            var result = JSON.parse(resJson);
            __nativeLog__("工业品直播任务", JSON.stringify(result.data));
        });
}

function getPopUrl(url){
    var queryType = bean.actionParam.queryType;
    var queryParam = bean.actionParam.queryParam;

    __nativeLog__("工业品直播任务","queryType:" + queryType + "queryParam:" + queryParam);

     var resultUrl = url + "&useLaunchExtendQueryMode=true" + "&launchQueryType=" + queryType + "&launchQueryParam=" + queryParam + "&taskId=" + runingid + "&statusId=" + bean.statusId;

    __nativeLog__("工业品直播任务",JSON.stringify(resultUrl));
    return resultUrl;
}

function setLastEvent(scene,trigger,params) {
    var params = {
        id: runingid,
        scene:scene,
        trigger:trigger,
        params:params
    };
    WVBridge("UIWvApiPlugin","lastEvent",params,function(data){
        __nativeLog__("工业品直播任务","上个event：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function updateInfo(bean,scene,trigger,action,eventparams,status) {
    var benstr = JSON.stringify(bean);
    var event = {
            sceneName: scene,
            triggerName:trigger,
            actionName:action
        };
    var eventstr = JSON.stringify(event);

    var eventparamsobj = JSON.parse(eventparams);//这是个string

    var eveObj = JSON.parse(eventparamsobj);//这才是obj

    eveObj.currentIndex = currentIndex;
    var evetPaStr = JSON.stringify(eveObj);

    var timestamp=new Date().getTime();
    var randomNumber = Math.floor(Math.random()*Math.floor(100000));
    var extInfo = {
        flowId : 111,
        processorId : bean.id,
        status : status,
        currentIndex: currentIndex
    };

    var params = {
        id: runingid,
        bean: benstr,
        event:eventstr,
        eventparams:evetPaStr,
        status:status,
        currentTime: timestamp,
        uniqueId: randomNumber,
        extInfo: extInfo,
        bizCode: bean.bizCode,
        currentIndex: currentIndex
    };

    __nativeLog__("","updateInfo: " + JSON.stringify(params));

    WVBridge("UIWvApiPlugin","updateInfo",params,function(data){
        __nativeLog__("工业品直播任务","上传信息：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function sendFatigue(bizCode,flowId,processorId){
    var bizCodestr = JSON.stringify(bizCode);
    var flowIdstr = JSON.stringify(flowId);
    var processorIdstr = JSON.stringify(processorId);

    var params = {
        bizCode: bizCodestr,
        flowId: flowIdstr,
        processorId: processorIdstr
    }

    WVBridge("MtopWVPlugin","send",{
            api:'mtop.taobao.widgetService.getJsonComponentRequireLogin',
            v:'2.0',
            param:{
                cid:'getFatigueRule:getFatigueRule',
                methodName:'execute',
                params:JSON.stringify(params)
            },
            ecode:0
        },(resJson) => {
            __nativeLog__("工业品直播任务",typeof resJson);
            __nativeLog__("工业品直播任务",resJson);
            var result = JSON.parse(resJson);
            if(result && result.data && result.data.rstModel && result.data.rstModel.result &&
            result.data.rstModel.result.pass){
                isRunning=true;
                __nativeLog__("工业品直播任务", "isRunning: " + isRunning);

            }
        },(resJson) =>{
            isRunning=false;
            __nativeLog__("fail",resJson);
            var result = JSON.parse(resJson);
                __nativeLog__("工业品直播任务", JSON.stringify(result.data));
        });
}


function saveFatigueMessage(){
    __nativeLog__("工业品直播任务","开始存储疲劳配置至本地");
    __nativeLog__("工业品直播任务","任务是否结束： " + isFinished);
    var jsonObj = {
        startTime: startTime,
        validTime: validTime,
        resetTime: resetTime,
        isFinished:isFinished
    }
    var jsonObjStr = JSON.stringify(jsonObj);
    var params = {
        File: spFileName,
        key: spFatigueKey,
        value: jsonObjStr
    };
    var paramsStr = JSON.stringify(params);
    __nativeLog__("工业品直播任务","params: " + paramsStr);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__("工业品直播任务","成功写入疲劳配置：" + data);
        },function(err){
            __nativeLog__("fail","写入疲劳配置失败：" + err);
        });
}

function readFatigueMessage(){
    __nativeLog__("工业品直播任务","开始读取本地疲劳配置");

    var params = {
        File: spFileName,
        key: spFatigueKey,
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__("工业品直播任务","读取的data： " + data);
        var json = JSON.parse(data);
        var fatigueJsonStr = json.data.data;
        //获取当前时间
        var currentTime = new Date().getTime();
        __nativeLog__("工业品直播任务","currenttime : " + currentTime +" fatigueJsonStr： " + fatigueJsonStr);

        if( typeof fatigueJsonStr == "undefined" || fatigueJsonStr == null || fatigueJsonStr == ""){
            //初始状态下， 初始化疲劳相关参数，但不写入。 在触发第一个行动点时写入。
            startTime = currentTime;
            validTime = currentTime + oneDayTime;
            resetTime = currentTime + oneDayTime + oneDayTime;
            isPass = true;
            isReset = false;

            __nativeLog__("工业品直播任务","时间未定义");

        }else{
            //若有数据，获取疲劳参数。
            fatigueObj = JSON.parse(fatigueJsonStr);
            startTime=fatigueObj.startTime;
            validTime=fatigueObj.validTime;
            resetTime=fatigueObj.resetTime;
            isFinished=fatigueObj.isFinished;

            //疲劳判断 (0 ~ 24 小时间， 若没完成，则执行任务)
            if(currentTime >= startTime && currentTime <= validTime && !isFinished){
                isPass = true;
                isReset = false;
                __nativeLog__("工业品直播任务","0～24");

            }
            //疲劳判断 (24 ~ 48 小时间， 隐藏任务)
            if(currentTime >= validTime && currentTime <= resetTime){
                isPass = false;
                isReset = false;
                __nativeLog__("工业品直播任务","24～48");
            }
            //疲劳判断( 48小时以上， 若没完成任务， 任务重置)
            if(currentTime >= resetTime){
                startTime = currentTime;
                validTime = currentTime + oneDayTime;
                resetTime = currentTime + oneDayTime + oneDayTime;
                isPass = true;
                isReset = true;
                isFinished = false;
                __nativeLog__("工业品直播任务","48+");
            }
        }
        __nativeLog__("工业品直播任务","startTime : " + startTime + " validTime : " + validTime + " resetTime : " + resetTime + " isPass : " + isPass + " isReset : " + isReset);
    },function(err){
        __nativeLog__("fail",err);
    });
}



function closeCurrentPop(){
     if(!isEmpty(showingPoplayerUrl)){
         closeTouch(showingPoplayerUrl);
      }
}

function closeCurrentTouch(){
    if(!isEmpty(showingTouchUrl)){
        closeTouch(showingTouchUrl);
     }
}


function isEmpty(obj){
    if(typeof obj == "undefined" || obj == null || obj == ""){
        return true;
    }else{
        return false;
    }
}


function finishCurrent() {
    var params = {
        id: runingid
    };
    WVBridge("UIWvApiPlugin","finishCurrent",params,function(data){
        __nativeLog__("工业品直播任务","结束当前节点" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}



function showPopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showPoplayer",params,function(data){
        __nativeLog__("工业品直播任务","显示poplayer：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function showTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showTouch",params,function(data){
        __nativeLog__("工业品直播任务","展示Touch：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function saveOfferNum(num){
    __nativeLog__("工业品直播任务","存储num：" + num);
    var params = {
        File: spFileName,
        key: spKey,
        value: num
    };
    __nativeLog__("工业品直播任务","params" + params);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__("工业品直播任务","写入成功：" + data);
        },function(err){
            __nativeLog__("fail",err);
        });
}

function readOfferNum(){
    var params = {
        File: spFileName,
        key: spKey
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__("工业品直播任务","读取的data： " + data);
        var json = JSON.parse(data);
        offernum = parseInt(json.data.data);
        __nativeLog__("工业品直播任务","读取的num： " + offernum);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closePopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closePoplayer",params,function(data){
        __nativeLog__("工业品直播任务",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closeTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closeTouch",params,function(data){
        __nativeLog__("工业品直播任务",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}


function HashMap(){
    var length = 0;
    var obj = new Object();

    this.isEmpty = function(){
        return length == 0;
    };

    this.containsKey=function(key){
        return (key in obj);
    };

    this.containsValue=function(value){
        for(var key in obj){
            if(obj[key] == value){
                return true;
            }
        }
        return false;
    };

    this.put=function(key,value){
        if(!this.containsKey(key)){
            length++;
        }
        obj[key] = value;
    };

    this.get=function(key){
        return this.containsKey(key)?obj[key]:null;
    };

    this.remove=function(key){
        if(this.containsKey(key)&&(delete obj[key])){
            length--;
        }
    };

    this.values=function(){
        var _values= new Array();
        for(var key in obj){
            _values.push(obj[key]);
        }
        return _values;
    };

    this.keySet=function(){
        var _keys = new Array();
        for(var key in obj){
            _keys.push(key);
        }
        return _keys;
    };

    this.size = function(){
        return length;
    };

    this.clear = function(){
        length = 0;
        obj = new Object();
    };
}

