var runingid ;
var showingPoplayerUrl='';
var showingTouchUrl='';
var spFileName='SEARCH_GUIDE_INFO_COMPUTE';
var spKey='SEARCH_GUIDE_TIME';
var spFatigueKey='FATIGUE_KEY'
var startTime=0;
var validTime=0;
var resetTime=0;
var isFinished=false;
var isPass=false;
var isReset=false;

var bean;
var baseinfo;
var isBegin=false;
var isInHome;
var pageMap;
var isRunning=false;
var isFirstIn=true;
var oneDayTime = 86400000;



function init(params,platform){
      bean = JSON.parse(params);
      baseinfo = JSON.parse(platform);
      runingid = bean.id;
      pageMap = new HashMap(); 
      __nativeLog__("任务1","id: " + runingid);
      //疲劳统一在子纳那边控，根据是否出物料来
      readFatigueMessage();
}


function destroy() {

}

function onMessage(scene,trigger,params){

    var paramsobj = JSON.parse(params);
    var action = paramsobj.actionName;
    var flowId = bean.statusId;
    var bizCode = bean.bizCode;

    __nativeLog__("任务1", "任务1 " + scene + " trigger : " + trigger + " action : " + action);

    if(trigger == 'enter' && action == 'Page_Home'){
        updateInfo(bean,scene,trigger,action,params,'begin');
        __nativeLog__("任务1", "updateinfo");
        __nativeLog__("任务1", "开始上报疲劳");
        sendFatigue(bizCode,flowId,runingid);
    }


    if((scene == 'Page_Home'
    && action == 'Page_chimera_6335_Home_Back_Toast') ||
    (scene == 'Page_Home'
    && action == 'Home_Back_Toast')){

        __nativeLog__("任务1", "捕捉到退出事件");

        var url = "https://cybert.m.1688.com/page/u6q8zftn.html?sceneName=chimera_15578&poplayerType=cyberT";
        showPopLayer(url);

        updateInfo(bean,scene,trigger,action,params,'end');
        __nativeLog__("任务1", "updateinfo ");
    }

}

//读取本地疲劳配置
function readFatigueMessage(){
    __nativeLog__("任务1","开始读取本地疲劳配置");

    var params = {
        File: spFileName,
        key: spFatigueKey,
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__("任务1","读取的data： " + data);
        var json = JSON.parse(data);
        var fatigueJsonStr = json.data.data;
        //获取当前时间
        var currentTime = new Date().getTime();
        if( typeof dataStr == "undefined" || dataStr == null || dataStr == ""){
            //初始状态下， 初始化疲劳相关参数，但不写入。 在触发第一个行动点时写入。
            startTime = currentTime;
            validTime = currentTime + oneDayTime;
            resetTime = currentTime + oneDayTime + oneDayTime;
            isPass = true;
            isReset = false;
        }else{
            //若有数据，获取疲劳参数。
            fatigueObj = JSON.parse(fatigueJsonStr);
            startTime=fatigueObj.startTime;
            validTime=fatigueObj.validTime;
            resetTime=fatigueObj.resetTime;
            isFinished=fatigueObj.isFinished;

            //疲劳判断 (0 ~ 24 小时间， 若没完成，则执行任务)
            if(currentTime >= startTime && currentTime <= validTime && !isFinished){
                isPass = true;
                isReset = false;
            }
            //疲劳判断 (24 ~ 48 小时间， 隐藏任务)
            if(currentTime >= validTime && currentTime <= resetTime){
                isPass = false;
                isReset = false;
            }
            //疲劳判断( 48小时以上， 若没完成任务， 任务重置)
            if(currentTime >= resetTime && !isFinished){
                startTime = currentTime;
                validTime = currentTime + oneDayTime;
                resetTime = currentTime + oneDayTime + oneDayTime;
                isPass = true;
                isReset = true;
            }
        }
        __nativeLog__("任务1","startTime : " + startTime + " validTime : " + validTime + " resetTime : " + resetTime + " isPass : " + isPass + " isReset : " + isReset);
    },function(err){
        __nativeLog__("fail",err);
    });
}

//本地存储疲劳
function saveFatigueMessage(){
    __nativeLog__("任务1","开始存储疲劳配置至本地");
    __nativeLog__("任务1","任务是否结束： " + isFinished);
    var jsonObj = {
        startTime: startTime,
        validTime: validTime,
        resetTime: resetTime,
        isFinished:isFinished
    }
    var jsonObjStr = JSON.stringify(jsonObj);
    var params = {
        File: spFileName,
        key: spFatigueKey,
        value: jsonObjStr
    };
    var paramsStr = JSON.stringify(params);
    __nativeLog__("任务1","params: " + paramsStr);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__("任务1","成功写入疲劳配置：" + data);
        },function(err){
            __nativeLog__("fail","写入疲劳配置失败：" + err);
        });
}

function getPopUrl(url){
    var queryType = bean.actionParam.queryType;
    var queryParam = bean.actionParam.queryParam;

    __nativeLog__("任务1","queryType:" + queryType + "queryParam:" + queryParam);

     var resultUrl = url + "&useLaunchExtendQueryMode=true" + "&launchQueryType=" + queryType + "&launchQueryParam=" + queryParam + "&taskId=" + runingid + "&statusId=" + bean.statusId;

    __nativeLog__("任务1",JSON.stringify(resultUrl));
    return resultUrl;
}

function setLastEvent(scene,trigger,params) {
    var params = {
        id: runingid,
        scene:scene,
        trigger:trigger,
        params:params
    };
    WVBridge("UIWvApiPlugin","lastEvent",params,function(data){
        __nativeLog__("任务1","上个event：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function updateInfo(bean,scene,trigger,action,eventparams,status) {
    var benstr = JSON.stringify(bean);
    var event = {
            sceneName: scene,
            triggerName:trigger,
            actionName:action
        };
    var eventstr = JSON.stringify(event);

    var eventparamsobj = JSON.parse(eventparams)
    if(!eventparamsobj.bizCode){
        eventparamsobj.bizCode = bean.bizCode;
        eventparamsobj.evtParam = event;
        var extInfo = {
            flowId : bean.statusId,
            processorId : bean.id,
            status : status
        }
        eventparamsobj.extInfo = extInfo;
        var randomNumber = Math.floor(Math.random()*Math.floor(100000));
        var timestamp=new Date().getTime();
        eventparamsobj.clientTime=timestamp;
        eventparamsobj.uniqueId= randomNumber + "_" + timestamp;
    }

    var eventparamsstr = JSON.stringify(eventparamsobj);
    var params = {
        id: runingid,
        bean: benstr,
        event:eventstr,
        eventparams:eventparamsstr,
        status:status
    };

    __nativeLog__("任务1","updateInfo: " + JSON.stringify(params));

    WVBridge("UIWvApiPlugin","updateInfo",params,function(data){
        __nativeLog__("任务1","上传信息：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function sendFatigue(bizCode,flowId,processorId){
    var bizCodestr = JSON.stringify(bizCode);
    var flowIdstr = JSON.stringify(flowId);
    var processorIdstr = JSON.stringify(processorId);

    var params = {
        bizCode: bizCodestr,
        flowId: flowIdstr,
        processorId: processorIdstr
    }

    WVBridge("MtopWVPlugin","send",{
            api:'mtop.taobao.widgetService.getJsonComponentRequireLogin',
            v:'2.0',
            param:{
                cid:'getFatigueRule:getFatigueRule',
                methodName:'execute',
                params:JSON.stringify(params)
            },
            ecode:0
        },(resJson) => {
            __nativeLog__("任务1",typeof resJson);
            __nativeLog__("任务1",resJson);
            var result = JSON.parse(resJson);
            if(result && result.data && result.data.rstModel && result.data.rstModel.result &&
            result.data.rstModel.result.pass){
                isRunning=true;
                __nativeLog__("任务1", "isRunning: " + isRunning);

            }
        },(resJson) =>{
            isRunning=false;
            __nativeLog__("fail",resJson);
            var result = JSON.parse(resJson);
                __nativeLog__("任务1", JSON.stringify(result.data));
        });
}


function closeCurrentPop(){
     if(isEmpty(showingPoplayerUrl)){
         closeTouch(showingPoplayerUrl);
      }
}

function closeCurrentTouch(){
    if(isEmpty(showingTouchUrl)){
        closeTouch(showingTouchUrl);
     }
}


function finishCurrent() {
    var params = {
        id: runingid
    };
    WVBridge("UIWvApiPlugin","finishCurrent",params,function(data){
        __nativeLog__("任务1","结束当前节点" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}


// 兼容 runningui.handler 为空的case
function showPopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    __nativeLog__("任务1","params：" + JSON.stringify(params));

    WVBridge("UIWvApiPlugin","showPoplayer",params,function(data){
        __nativeLog__("任务1","显示poplayer：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function showTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showTouch",params,function(data){
        __nativeLog__("任务1","展示Touch：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function saveOfferNum(num){
    __nativeLog__("任务1","存储num：" + num);
    var params = {
        File: spFileName,
        key: spKey,
        value: num
    };
    __nativeLog__("任务1","params" + params);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__("任务1","写入成功：" + data);
        },function(err){
            __nativeLog__("fail",err);
        });
}

function readOfferNum(){
    var params = {
        File: spFileName,
        key: spKey
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__("任务1","读取的data： " + data);
        var json = JSON.parse(data);
        offernum = parseInt(json.data.data);
        __nativeLog__("任务1","读取的num： " + offernum);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closePopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closePoplayer",params,function(data){
        __nativeLog__("任务1",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closeTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closeTouch",params,function(data){
        __nativeLog__("任务1",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}


function HashMap(){
    var length = 0;
    var obj = new Object();

    this.isEmpty = function(){
        return length == 0;
    };

    this.containsKey=function(key){
        return (key in obj);
    };

    this.containsValue=function(value){
        for(var key in obj){
            if(obj[key] == value){
                return true;
            }
        }
        return false;
    };

    this.put=function(key,value){
        if(!this.containsKey(key)){
            length++;
        }
        obj[key] = value;
    };

    this.get=function(key){
        return this.containsKey(key)?obj[key]:null;
    };

    this.remove=function(key){
        if(this.containsKey(key)&&(delete obj[key])){
            length--;
        }
    };

    this.values=function(){
        var _values= new Array();
        for(var key in obj){
            _values.push(obj[key]);
        }
        return _values;
    };

    this.keySet=function(){
        var _keys = new Array();
        for(var key in obj){
            _keys.push(key);
        }
        return _keys;
    };

    this.size = function(){
        return length;
    };

    this.clear = function(){  
        length = 0;  
        obj = new Object();  
    };  
}
