var runingid ;
var showingPoplayerUrl='';
var showingTouchUrl='';
var spFileName='SEARCH_GUIDE_INFO_COMPUTE';
var spKey='SEARCH_GUIDE_TIME';
var bean;
var baseinfo;
var isBegin=false;
var isInHome;
var pageMap;
var isRunning=false;


function init(params,platform){
      bean = JSON.parse(params);
      baseinfo = JSON.parse(platform);
      runingid = bean.id;
      pageMap = new HashMap(); 
      __nativeLog__("任务2",runingid);
}


function destroy() {

}

function onMessage(scene,trigger,params){

    var paramsobj = JSON.parse(params);
    var action = paramsobj.actionName;
    var flowId = bean.statusId;
    var bizCode = bean.bizCode;

    __nativeLog__("任务2", "scene: " + scene + " trigger : " + trigger + " action : " + action);

    if(trigger == 'enter'
        && action == 'Page_Home'){
        updateInfo(bean,scene,trigger,action,params,'begin');
            __nativeLog__("任务2", "刚进入时 updateinfo");
    }


    if(trigger == 'custom'
    && action == 'Phone_Home_Click'){

        __nativeLog__("任务2", "捕捉到Home事件");
        //scene 更改， 方便弈清统计
        updateInfo(bean,'Phone_Home_Click',trigger,action,params,'end');
        __nativeLog__("任务2", "退出Home时的updateInfo");
    }

}

function getPopUrl(url){
    var queryType = bean.actionParam.queryType;
    var queryParam = bean.actionParam.queryParam;

    __nativeLog__("任务2","queryType:" + queryType + "queryParam:" + queryParam);

     var resultUrl = url + "&useLaunchExtendQueryMode=true" + "&launchQueryType=" + queryType + "&launchQueryParam=" + queryParam + "&taskId=" + runingid + "&statusId=" + bean.statusId;

    __nativeLog__("任务2",JSON.stringify(resultUrl));
    return resultUrl;
}

function setLastEvent(scene,trigger,params) {
    var params = {
        id: runingid,
        scene:scene,
        trigger:trigger,
        params:params
    };
    WVBridge("UIWvApiPlugin","lastEvent",params,function(data){
        __nativeLog__("任务2","上个event：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function updateInfo(bean,scene,trigger,action,eventparams,status) {
    var benstr = JSON.stringify(bean);
    var event = {
            sceneName: scene,
            triggerName:trigger,
            actionName:action
        };
    var eventstr = JSON.stringify(event);

    var eventparamsobj = JSON.parse(eventparams)
    if(!eventparamsobj.bizCode){
        eventparamsobj.bizCode = bean.bizCode;
        eventparamsobj.evtParam = event;
        var extInfo = {
            flowId : bean.statusId,
            processorId : bean.id,
            status : status
        }
        eventparamsobj.extInfo = extInfo;
        var randomNumber = Math.floor(Math.random()*Math.floor(100000));
        var timestamp=new Date().getTime();
        eventparamsobj.clientTime=timestamp;
        eventparamsobj.uniqueId= randomNumber + "_" + timestamp;
    }

    var eventparamsstr = JSON.stringify(eventparamsobj);
    var params = {
        id: runingid,
        bean: benstr,
        event:eventstr,
        eventparams:eventparamsstr,
        status:status
    };

    __nativeLog__("任务2","updateInfo: " + JSON.stringify(params));

    WVBridge("UIWvApiPlugin","updateInfo",params,function(data){
        __nativeLog__("任务2","上传信息：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function sendFatigue(bizCode,flowId,processorId){
    var bizCodestr = JSON.stringify(bizCode);
    var flowIdstr = JSON.stringify(flowId);
    var processorIdstr = JSON.stringify(processorId);

    var params = {
        bizCode: bizCodestr,
        flowId: flowIdstr,
        processorId: processorIdstr
    }

    WVBridge("MtopWVPlugin","send",{
            api:'mtop.taobao.widgetService.getJsonComponentRequireLogin',
            v:'2.0',
            param:{
                cid:'getFatigueRule:getFatigueRule',
                methodName:'execute',
                params:JSON.stringify(params)
            },
            ecode:0
        },(resJson) => {
            __nativeLog__("任务2",typeof resJson);
            __nativeLog__("任务2",resJson);
            var result = JSON.parse(resJson);
            if(result && result.result && result.result.pass){
                isRunning=true;
                __nativeLog__("任务2", JSON.stringify(result.data));

            }
        },(resJson) =>{
            isRunning=false;
            __nativeLog__("fail",resJson);
            var result = JSON.parse(resJson);
                __nativeLog__("任务2", JSON.stringify(result.data));
        });
}


function closeCurrentPop(){
     if(isEmpty(showingPoplayerUrl)){
         closeTouch(showingPoplayerUrl);
      }
}

function closeCurrentTouch(){
    if(isEmpty(showingTouchUrl)){
        closeTouch(showingTouchUrl);
     }
}


function finishCurrent() {
    var params = {
        id: runingid
    };
    WVBridge("UIWvApiPlugin","finishCurrent",params,function(data){
        __nativeLog__("任务2","结束当前节点" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}



function showPopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showPoplayer",params,function(data){
        __nativeLog__("任务2","显示poplayer：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function showTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showTouch",params,function(data){
        __nativeLog__("任务2","展示Touch：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function saveOfferNum(num){
    __nativeLog__("任务2","存储num：" + num);
    var params = {
        File: spFileName,
        key: spKey,
        value: num
    };
    __nativeLog__("任务2","params" + params);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__("任务2","写入成功：" + data);
        },function(err){
            __nativeLog__("fail",err);
        });
}

function readOfferNum(){
    var params = {
        File: spFileName,
        key: spKey
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__("任务2","读取的data： " + data);
        var json = JSON.parse(data);
        offernum = parseInt(json.data.data);
        __nativeLog__("任务2","读取的num： " + offernum);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closePopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closePoplayer",params,function(data){
        __nativeLog__("任务2",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closeTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closeTouch",params,function(data){
        __nativeLog__("任务2",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}


function HashMap(){
    var length = 0;
    var obj = new Object();

    this.isEmpty = function(){
        return length == 0;
    };

    this.containsKey=function(key){
        return (key in obj);
    };

    this.containsValue=function(value){
        for(var key in obj){
            if(obj[key] == value){
                return true;
            }
        }
        return false;
    };

    this.put=function(key,value){
        if(!this.containsKey(key)){
            length++;
        }
        obj[key] = value;
    };

    this.get=function(key){
        return this.containsKey(key)?obj[key]:null;
    };

    this.remove=function(key){
        if(this.containsKey(key)&&(delete obj[key])){
            length--;
        }
    };

    this.values=function(){
        var _values= new Array();
        for(var key in obj){
            _values.push(obj[key]);
        }
        return _values;
    };

    this.keySet=function(){
        var _keys = new Array();
        for(var key in obj){
            _keys.push(key);
        }
        return _keys;
    };

    this.size = function(){
        return length;
    };

    this.clear = function(){  
        length = 0;  
        obj = new Object();  
    };  
}
