var runingid ;
var showingPoplayerUrl='';
var showingTouchUrl='';
var spFileName='CANCEL_AFTER_VERIFICATION';
var spKey='CANCEL_CURRENT_INDEX';
var bean;
var baseinfo;
var isBegin=false;
var isInHome;
var pageMap;
var isRunning=false;
var currentIndex=1;


function init(params,platform){
      bean = JSON.parse(params);
      baseinfo = JSON.parse(platform);
      runingid = bean.id;
      pageMap = new HashMap();
      __nativeLog__("success",runingid);
      readCurrentIndex();
}


function destroy() {

}

function onMessage(scene,trigger,params){
    __nativeLog__("success", "进入" + scene);

    var paramsobj = JSON.parse(params);
    var action = paramsobj.actionName;
    var flowId = bean.statusId;
    var bizCode = bean.bizCode;

    var str = 'asdfadfsafasdfa';
    str.replace(/Microsoft/g, "W3School");

    if(scene == 'Page_Detail' && trigger == 'enter'){
        getFatigueForCancelAfter(bizCode,flowId,runingid,scene,trigger,params,action);
    }

}

//每个子任务开始前都将通过该方法判断此次任务是否需要执行、重置
function getFatigueForCancelAfter(bizCode,flowId,processorId,scene,trigger,params,action){
    var bizCodestr = JSON.stringify(bizCode);
    var flowIdstr = JSON.stringify(flowId);
    var processorIdstr = JSON.stringify(processorId);

    //参数
    var params = {
        bizCode: bizCodestr,
        flowId: flowIdstr,
        processorId: processorIdstr
    }

    //mtop
    WVBridge("MtopWVPlugin","send",{
            api:'mtop.taobao.widgetService.getJsonComponentRequireLogin',
            v:'2.0',
            param:{
                cid:'getFatigueRule:getFatigueRule',
                methodName:'execute',
                params:JSON.stringify(params)
            },
            ecode:0
        },(resJson) => {
            __nativeLog__("success",resJson);
            var result = JSON.parse(resJson);

            taskOne(scene,trigger,params,action);
                                            
        },(resJson) =>{
            isRunning=false;
            __nativeLog__("fail",resJson);
            var result = JSON.parse(resJson);
            __nativeLog__("success", JSON.stringify(result.data));
        });
}

//第一个任务的执行逻辑, 发updateInfo, 弹红包、弹浮层，设置currentIndex=2 存入本地 发updateInfo
function taskOne(scene,trigger,params,action){
    //上报updateInfo
    __nativeLog__("success", "updateinfo");
    params.currentIndex = currentIndex;
    var paramsStr = JSON.stringify(params);
    updateInfo(bean,scene,trigger,action,paramsStr,'begin');

    //执行任务1
    __nativeLog__("success", "执行任务1");

    __nativeLog__("success", "获取额外参数 ： " + JSON.stringify(bean.actionParam.inParams));

    var url1 = "https://show.1688.com/yhzz/new/eupeavgm.html?wh_weex=true&cms_id=10955&__weex__=true&__pageId__=10955&useLaunchExtendQueryMode=true&launchQueryType=activityId&launchQueryParam=1139&spm=a262eq.10462506";

    //获取红包url
    var poplayerUrl1 = url1;
    __nativeLog__("success", "红包url ： " + poplayerUrl1);
    //弹出poplayer
    showPopLayer(poplayerUrl1);

    //设置任务1已执行完， 标记应该执行任务2
    currentIndex = 2;
    __nativeLog__("success", "currentIndex = " + currentIndex);
    saveCurrentIndex(2);

    __nativeLog__("success", "updateinfo end");
    updateInfo(bean,scene,trigger,action,paramsStr,'end');
}

//第二个任务的执行逻辑, 发updateInfo, 弹红包，设置currentIndex=3 存入本地 发updateInfo
function taskTwo(scene,trigger,params,action){
    //上报 updateInfo
    __nativeLog__("success", "updateinfo");
    params.currentIndex = currentIndex;
    var paramsStr = JSON.stringify(params);
    updateInfo(bean,scene,trigger,action,paramsStr,'begin');

    //执行任务2
    __nativeLog__("success", "执行任务2");

    __nativeLog__("success", "获取额外参数 ： " + JSON.stringify(bean.actionParam.inParams));
    var beanObj = bean.actionParam.inParams;

    //获取红包url
    var poplayerUrl2 = beanObj.poplayerUrl2;
    __nativeLog__("success", "红包url ： " + poplayerUrl2);
    //弹出poplayer
    showPopLayer(poplayerUrl2);

    //设置任务1已执行完， 标记应该执行任务3 即不用再执行了
    currentIndex = 3;
    __nativeLog__("success", "currentIndex = " + currentIndex);
    saveCurrentIndex(3);

    __nativeLog__("success", "updateinfo end");
    updateInfo(bean,scene,trigger,action,paramsStr,'end');

    finishCurrent;
}

function saveCurrentIndex(index){
     __nativeLog__("success","存储num：" + index);
    var params = {
        File: spFileName,
        key: spKey,
        value: index
    };
    var paramsStr = JSON.stringify(params);
    __nativeLog__("success","params" + paramsStr);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__("success","写入成功：" + data);
        },function(err){
            __nativeLog__("fail",err);
        });
}

function readCurrentIndex(){
    var params = {
        File: spFileName,
        key: spKey
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__("success","读取的data： " + data);
        var json = JSON.parse(data);
        var dataStr = json.data.data;
        if( typeof dataStr == "undefined" || dataStr == null || dataStr == ""){
            //初始情况下，执行第一个任务
            currentIndex = 1;
        }else{
            currentIndex = parseInt(dataStr);
        }
        __nativeLog__("success","读取的num： " + currentIndex);
    },function(err){
        __nativeLog__("fail",err);
    });
}



function getPopUrl(url){
    var queryType = bean.actionParam.queryType;
    var queryParam = bean.actionParam.queryParam;

    __nativeLog__("success","queryType:" + queryType + "queryParam:" + queryParam);

     var resultUrl = url + "&taskId=" + runingid + "&statusId=" + bean.statusId;

    __nativeLog__("success",JSON.stringify(resultUrl));
    return resultUrl;
}

function setLastEvent(scene,trigger,params) {
    var params = {
        id: runingid,
        scene:scene,
        trigger:trigger,
        params:params
    };
    WVBridge("UIWvApiPlugin","lastEvent",params,function(data){
        __nativeLog__("success","上个event：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function updateInfo(bean,scene,trigger,action,eventparams,status) {
    var benstr = JSON.stringify(bean);
    var event = {
            sceneName: scene,
            triggerName:trigger,
            actionName:action
        };
    var eventstr = JSON.stringify(event);

    var eventparamsobj = JSON.parse(eventparams)
    if(!eventparamsobj.bizCode){
        eventparamsobj.bizCode = bean.bizCode;
        eventparamsobj.evtParam = event;
        var extInfo = {
            flowId : bean.statusId,
            processorId : bean.id,
            status : status
        }
        eventparamsobj.extInfo = extInfo;
        var randomNumber = Math.floor(Math.random()*Math.floor(100000));
        var timestamp=new Date().getTime();
        eventparamsobj.clientTime=timestamp;
        eventparamsobj.uniqueId= randomNumber + "_" + timestamp;
    }

    var eventparamsstr = JSON.stringify(eventparamsobj);
    var params = {
        id: runingid,
        bean: benstr,
        event:eventstr,
        eventparams:eventparamsstr,
        status:status
    };

    __nativeLog__("success","updateInfo: " + JSON.stringify(params));

    WVBridge("UIWvApiPlugin","updateInfo",params,function(data){
        __nativeLog__("success","上传信息：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function sendFatigue(bizCode,flowId,processorId){
    var bizCodestr = JSON.stringify(bizCode);
    var flowIdstr = JSON.stringify(flowId);
    var processorIdstr = JSON.stringify(processorId);

    var params = {
        bizCode: bizCodestr,
        flowId: flowIdstr,
        processorId: processorIdstr
    }

    WVBridge("MtopWVPlugin","send",{
            api:'mtop.taobao.widgetService.getJsonComponentRequireLogin',
            v:'2.0',
            param:{
                cid:'getFatigueRule:getFatigueRule',
                methodName:'execute',
                params:JSON.stringify(params)
            },
            ecode:0
        },(resJson) => {
            __nativeLog__("success",typeof resJson);
            __nativeLog__("success",resJson);
            var result = JSON.parse(resJson);
            if(result && result.data && result.data.rstModel && result.data.rstModel.result &&
            result.data.rstModel.result.pass){
                isRunning=true;
                __nativeLog__("success", "isRunning: " + isRunning);

            }
        },(resJson) =>{
            isRunning=false;
            __nativeLog__("fail",resJson);
            var result = JSON.parse(resJson);
                __nativeLog__("success", JSON.stringify(result.data));
        });
}


function closeCurrentPop(){
     if(isEmpty(showingPoplayerUrl)){
         closeTouch(showingPoplayerUrl);
      }
}

function closeCurrentTouch(){
    if(isEmpty(showingTouchUrl)){
        closeTouch(showingTouchUrl);
     }
}


function finishCurrent() {
    var params = {
        id: runingid
    };
    WVBridge("UIWvApiPlugin","finishCurrent",params,function(data){
        __nativeLog__("success","结束当前节点" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}



function showPopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showPoplayer",params,function(data){
        __nativeLog__("success","显示poplayer：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function showTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showTouch",params,function(data){
        __nativeLog__("success","展示Touch：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function saveOfferNum(num){
    __nativeLog__("success","存储num：" + num);
    var params = {
        File: spFileName,
        key: spKey,
        value: num
    };
    __nativeLog__("success","params" + params);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__("success","写入成功：" + data);
        },function(err){
            __nativeLog__("fail",err);
        });
}

function readOfferNum(){
    var params = {
        File: spFileName,
        key: spKey
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__("success","读取的data： " + data);
        var json = JSON.parse(data);
        offernum = parseInt(json.data.data);
        __nativeLog__("success","读取的num： " + offernum);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closePopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closePoplayer",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closeTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closeTouch",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}


function HashMap(){
    var length = 0;
    var obj = new Object();

    this.isEmpty = function(){
        return length == 0;
    };

    this.containsKey=function(key){
        return (key in obj);
    };

    this.containsValue=function(value){
        for(var key in obj){
            if(obj[key] == value){
                return true;
            }
        }
        return false;
    };

    this.put=function(key,value){
        if(!this.containsKey(key)){
            length++;
        }
        obj[key] = value;
    };

    this.get=function(key){
        return this.containsKey(key)?obj[key]:null;
    };

    this.remove=function(key){
        if(this.containsKey(key)&&(delete obj[key])){
            length--;
        }
    };

    this.values=function(){
        var _values= new Array();
        for(var key in obj){
            _values.push(obj[key]);
        }
        return _values;
    };

    this.keySet=function(){
        var _keys = new Array();
        for(var key in obj){
            _keys.push(key);
        }
        return _keys;
    };

    this.size = function(){
        return length;
    };

    this.clear = function(){  
        length = 0;  
        obj = new Object();  
    };  
}

