#ifndef FaceChanging_hpp
#define FaceChanging_hpp

#include <iostream>
#include <fstream>
#include <iomanip>
#include <stdlib.h>
#include <vector>
#include <string>
#include <math.h>

using namespace std;

class emotionDetector {
public:
    emotionDetector();
    ~emotionDetector() {}
    
public:
    //face shake related
    int faceShakeEffectCounter;
    bool faceSideFlag;
    int faceShakeCounter;
    bool faceSideFlagL;
    bool faceSideFlagR;
    bool leftTrigger;
    bool rightTrigger;
    int faceSideCounter;
    int finishCounter;
    
    //mouth open related
    int mouthOpenEffectCounter;
    bool mouthOpenFlag;
    
    //one eye blink related
    int oneEyeBlinkEffectCounter;
    bool oneEyeBlinkFlag;
    
    //kiss related
    int kissEffectCounter;
    bool kissFlag;

public:
    float ptDist(float x0, float y0, float x1, float y1);
    float getClosestDist(float cx, float cy, float ax,float ay, float bx,float by);
    void faceShakeDetector(float * ppFaceLandmark);
    void mouthOpenDetector(float * ppFaceLandmark);
    void oneEyeBlinkDetector(float * ppFaceLandmark);
    void kissDetector(float * ppFaceLandmark);
};
#endif
    
    
    
    
    
    
    
    
    
    
    
