var runingid;
var showingPoplayerUrl='';
var showingTouchUrl='';
var bean;
var baseinfo;

function init(params,platform) {
      bean = JSON.parse(params);
      baseinfo = JSON.parse(platform);
      runingid = bean.id;
      __nativeLog__("success",runingid);
}

function destroy() {

}

function onMessage(scene,trigger,params){
     //进入新人，展示提醒，同时关闭当前任务，存储最后的状态，启动下一个任务
     if(scene == 'Page_NewUser' && trigger == 'enter'){
         var paramsobj = JSON.parse(params);
         var action = paramsobj.actionName;

         updateInfo(bean,scene,trigger,action,params,'begin');

         var url = "https://show.1688.com/yhzz/new/eupeavgm.html?wh_weex=true&cms_id=10955&__weex__=true&__pageId__=10955";

         showingPoplayerUrl = getPopUrl(url);
         showPopLayer(showingPoplayerUrl);
         setLastEvent(scene,trigger,params);
         return;
     }

     if(scene == 'Page_NewUser' && trigger == 'DiscountFinish'){
         updateInfo(bean,scene,trigger,action,params,'end');
         finishCurrent();
     }
}

function getPopUrl(url){
    var queryType = bean.actionParam.queryType;
    var queryParam = bean.actionParam.queryParam;

    __nativeLog__("success","queryType:" + queryType + "queryParam:" + queryParam);

     var resultUrl = url + "&useLaunchExtendQueryMode=true" + "&launchQueryType=" + queryType + "&launchQueryParam=" + queryParam + "&taskId=" + runingid + "&statusId=" + bean.statusId;


    __nativeLog__("success",JSON.stringify(resultUrl));
    return resultUrl;
}



function closeCurrentPop(){
     if(isEmpty(showingPoplayerUrl)){
         closeTouch(showingPoplayerUrl);
     }
}

function closeCurrentTouch(){
    if(isEmpty(showingTouchUrl)){
        closeTouch(showingTouchUrl);
    }
}

function isEmpty(obj){
    if(typeof obj == "undefined" || obj == null || obj == ""){
        return true;
    }else{
        return false;
    }
}


function updateInfo(bean,scene,trigger,action,eventparams,status) {
    var benstr = JSON.stringify(bean);
    var event = {
            sceneName: scene,
            triggerName:trigger,
            actionName:action
        };
    var eventstr = JSON.stringify(event);
    var params = {
        id: runingid,
        bean: benstr,
        event:eventstr,
        eventparams:eventparams,
        status:status
    };
    WVBridge("UIWvApiPlugin","updateInfo",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}



function setLastEvent(scene,trigger,params) {
    var params = {
        id: runingid,
        scene:scene,
        trigger:trigger,
        params:params
    };
    WVBridge("UIWvApiPlugin","lastEvent",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}



function finishCurrent() {
    var params = {
        id: runingid
    };
    WVBridge("UIWvApiPlugin","finishCurrent",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}



function showPopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showPoplayer",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function showTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showTouch",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closePopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closePoplayer",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closeTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closeTouch",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}
