var runingid ;
var showingPoplayerUrl='';
var showingTouchUrl='';
var spFileName='OD_INFO_COMPUTE';
var spKey='OD_INFO_NUM';
var bean;
var baseinfo;
var offernum = 0;
var offerIds1 =0;
var offerIds2 =0;
var offerIds3 =0;
var isBegin=false;

function init(params,platform){
      bean = JSON.parse(params);
      baseinfo = JSON.parse(platform);
      runingid = bean.id;
      __nativeLog__("success",runingid);
      readOfferNum();
}


function destroy() {

}

function onMessage(scene,trigger,params){
    __nativeLog__("success", "初次进入" + scene);

    if(scene == 'Page_Detail' && trigger == 'enter'){
        offernum++;
        saveOfferNum(offernum);
        var paramsobj = JSON.parse(params);
        __nativeLog__("success","+1 完后 offernum：" + offernum);
        __nativeLog__("success","offerId: " + paramsobj.offerId);

        if(offernum == 1){
           offerIds1 = paramsobj.offerId;//能拿offerId， 可以做去重
        }
        if(offernum == 2){
           offerIds2 = paramsobj.offerId;
        }
        if(offernum == 3){
           offerIds3 = paramsobj.offerId;
        }
    }

    //进入新人，展示提醒
    if(scene == 'Page_Detail' && trigger == 'enter'
       || scene == 'Page_NewUser' && trigger == 'enter'
       || scene == 'Page_Search' && trigger == 'enter'){
        var paramsobj = JSON.parse(params);
        var action = paramsobj.actionName;
        if(!isBegin){
            updateInfo(bean,scene,trigger,action,params,'begin');
            isBegin=true;
        }
        var url1 = "https://cybert.m.1688.com/test/index.html?sceneName=chimera_10697&params=viewoffernum_all3_now0";

        if(offernum == 1){
            url1 = "https://cybert.m.1688.com/test/index.html?sceneName=chimera_10697&params=viewoffernum_all3_now1";
        }
        if(offernum == 2){
            url1 = "https://cybert.m.1688.com/test/index.html?sceneName=chimera_10697&params=viewoffernum_all3_now2";
        }
        if(offernum < 3){
            showingTouchUrl = url1;
            showTouch(url1);
        }
    }

     //进入offer，展示红包
    if(offernum == 3 && scene == 'Page_Detail' && trigger == 'enter'){
        __nativeLog__("success","pop");
        var url = "https://show.1688.com/yhzz/new/eupeavgm.html?wh_weex=true&cms_id=10955&__weex__=true&__pageId__=10955";
        showingPoplayerUrl = getPopUrl(url);
        showPopLayer(showingPoplayerUrl);
        setLastEvent(scene,trigger,params);

        var paramsobj = JSON.parse(params);
        var action = paramsobj.actionName;
        var offerIds = [offerIds1, offerIds2, offerIds3];
        var offerIdsstr = JSON.stringify(offerIds);
        var eventparams = {
            offerNum:offernum,
            offerIds:offerIdsstr
        }
        var eventparamsstr = JSON.stringify(eventparams);

        if(isBegin){
            updateInfo(bean,scene,trigger,action,eventparamsstr,'end');
        }


        finishCurrent();
    }
}

function getPopUrl(url){
    var queryType = bean.actionParam.queryType;
    var queryParam = bean.actionParam.queryParam;

    __nativeLog__("success","queryType:" + queryType + "queryParam:" + queryParam);

     var resultUrl = url + "&useLaunchExtendQueryMode=true" + "&launchQueryType=" + queryType + "&launchQueryParam=" + queryParam + "&taskId=" + runingid + "&statusId=" + bean.statusId;

    __nativeLog__("success",JSON.stringify(resultUrl));
    return resultUrl;
}

function setLastEvent(scene,trigger,params) {
    var params = {
        id: runingid,
        scene:scene,
        trigger:trigger,
        params:params
    };
    WVBridge("UIWvApiPlugin","lastEvent",params,function(data){
        __nativeLog__("success","上个event：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function updateInfo(bean,scene,trigger,action,eventparams,status) {
    var benstr = JSON.stringify(bean);
    var event = {
            sceneName: scene,
            triggerName:trigger,
            actionName:action
        };
    var eventstr = JSON.stringify(event);
    var params = {
        id: runingid,
        bean: benstr,
        event:eventstr,
        eventparams:eventparams,
        status:status
    };
    WVBridge("UIWvApiPlugin","updateInfo",params,function(data){
        __nativeLog__("success","上传信息：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}


function closeCurrentPop(){
     if(isEmpty(showingPoplayerUrl)){
         closeTouch(showingPoplayerUrl);
      }
}

function closeCurrentTouch(){
    if(isEmpty(showingTouchUrl)){
        closeTouch(showingTouchUrl);
     }
}


function finishCurrent() {
    var params = {
        id: runingid
    };
    WVBridge("UIWvApiPlugin","finishCurrent",params,function(data){
        __nativeLog__("success","结束当前节点" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}



function showPopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showPoplayer",params,function(data){
        __nativeLog__("success","显示poplayer：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function showTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showTouch",params,function(data){
        __nativeLog__("success","展示Touch：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function saveOfferNum(num){
    __nativeLog__("success","存储num：" + num);
    var params = {
        File: spFileName,
        key: spKey,
        value: num
    };
    __nativeLog__("success","params" + params);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__("success","写入成功：" + data);
        },function(err){
            __nativeLog__("fail",err);
        });
}

function readOfferNum(){
    var params = {
        File: spFileName,
        key: spKey
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__("success","读取的data： " + data);
        var json = JSON.parse(data);
        var dataStr = json.data.data;
        if( typeof dataStr == "undefined" || dataStr == null || dataStr == ""){
            offernum = 0;
        }else{
            offernum = parseInt(dataStr);
        }
        __nativeLog__("success","读取的num： " + offernum);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closePopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closePoplayer",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closeTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closeTouch",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}
