
pha.on('pageShow', function(res) {
    console.log('pageShow:' + res.index);
});

pha.on('pageHide', function(res) {
    console.log('pageHide:' + res.index);
});

pha.on('tabBarItemClick', function(res) {
    console.log('tabBarItemClick:' + res.index);
});

pha.callBridge('WVUTABTestApi.activate', {
    component: 'Rewrite',
    module: 'https://huodong.taobao.com/wow/a/act/tao/tmc/23280/wupr?wh_pid=main-165447&spm=a211oj.13236708.6324963840.1.0&spm-url=a.b.c.d'
}, function(res) {
    console.log('windvane callback:' + res);
})

pha.setAppData(JSON.stringify({
    "tab": {
        "enable": true,
        "pageUrl": "",
        "tabBar": {
            "textColor": "#333333",
            "selectedColor": "#eb144c",
            "backgroundColor": "#ffffff",
            "borderStyle": "",
            "position": 2 //默认选中位置
        },
        "tabs": [
            {
                "pageName": "tab1",
                "url": "https://huodong.taobao.com/wow/a/act/tao/tmc/23280/wupr?wh_pid=industry-165433", // 页面地址
                "title": "主会场", // navBar title
                "tabBarItem": {
                    "name": "主会场",
                    "icon": "https://img.alicdn.com/tfs/TB1AE5Ida67gK0jSZFHXXa9jVXa-68-68.png",
                    "activeIcon": "https://img.alicdn.com/tfs/TB1XkmNdbH1gK0jSZFwXXc7aXXa-68-68.png"
                }
            },
            {
                "pageName": "tab2",
                "url": "https://huodong.taobao.com/wow/a/act/tao/tmc/23280/wupr?wh_pid=industry-165401", // 页面地址
                "title": "趋势会场", // navBar title
                "tabBarItem": {
                    "name": "趋势会场",
                    "icon": "https://img.alicdn.com/tfs/TB1zQ1JdhD1gK0jSZFsXXbldVXa-68-68.png",
                    "activeIcon": "https://img.alicdn.com/tfs/TB1akGKdhn1gK0jSZKPXXXvUXXa-68-68.png"
                }
            },
            {
                "pageName": "tab3",
                "url": "https://huodong.taobao.com/wow/a/act/tao/tmc/23280/wupr?wh_pid=industry-165426", // 页面地址
                "title": "新品打榜赛", // navBar title
                "tabBarItem": {
                    "name": "新品打榜赛",
                    "icon": "https://img.alicdn.com/tfs/TB1_zSKdhz1gK0jSZSgXXavwpXa-68-68.png",
                    "activeIcon": "https://img.alicdn.com/tfs/TB1XDWIdXY7gK0jSZKzXXaikpXa-68-68.png"
                }
            },
            {
                "pageName": "tab4",
                "url": "https://huodong.taobao.com/wow/a/act/tao/tmc/23280/wupr?wh_pid=industry-165420", // 页面地址
                "title": "全部会场", // navBar title
                "tabBarItem": {
                    "name": "全部会场",
                    "icon": "https://img.alicdn.com/tfs/TB1itaLdkY2gK0jSZFgXXc5OFXa-68-68.png",
                    "activeIcon": "https://img.alicdn.com/tfs/TB1hPuKdkP2gK0jSZPxXXacQpXa-68-68.png"
                }
            }
        ]
    },
    "window": {
        "enable": true
    }
}));