var runingid ;
var showingPoplayerUrl='';
var showingTouchUrl='';
var spFileName='SEARCH_GUIDE_INFO_COMPUTE';
var spKey='SEARCH_GUIDE_TIME';
var bean;
var baseinfo;
var isBegin=false;
var isInHome;
var pageMap;
var isRunning=false;


function init(params,platform){
      bean = JSON.parse(params);
      baseinfo = JSON.parse(platform);
      runingid = bean.id;
      pageMap = new HashMap();
      __nativeLog__("success",runingid);
}


function destroy() {

}

function onMessage(scene,trigger,params){
    __nativeLog__("success", "进入" + scene);

    var paramsobj = JSON.parse(params);
    var action = paramsobj.actionName;
    var flowId = bean.statusId;
    var bizCode = bean.bizCode;

    updateInfo(bean,scene,trigger,action,params,'begin');
    __nativeLog__("success", "updateinfo");

   // __nativeLog__("success", "开始上报疲劳");
    //sendFatigue(bizCode,flowId,runingid);

     if(scene == 'Page_Home' && trigger == 'custom'
           || scene == 'Page_Search' && trigger == 'custom'){
            var paramsobj = JSON.parse(params);
            var action = paramsobj.actionName;
            if(action == 'needSendCounpon'){
                    __nativeLog__("success", "捕捉到退出事件");
                    var url = "https://show.1688.com/hudong/yhzz/cmxd05w9.html?cms_id=17307&__pageId__=17307";
                    showingPoplayerUrl(url);
                    updateInfo(bean,scene,trigger,action,params,'end');
            }

     }

}

function getPopUrl(url){
    var queryType = bean.actionParam.queryType;
    var queryParam = bean.actionParam.queryParam;

    __nativeLog__("success","queryType:" + queryType + "queryParam:" + queryParam);

     var resultUrl = url + "&useLaunchExtendQueryMode=true" + "&launchQueryType=" + queryType + "&launchQueryParam=" + queryParam + "&taskId=" + runingid + "&statusId=" + bean.statusId;

    __nativeLog__("success",JSON.stringify(resultUrl));
    return resultUrl;
}

function setLastEvent(scene,trigger,params) {
    var params = {
        id: runingid,
        scene:scene,
        trigger:trigger,
        params:params
    };
    WVBridge("UIWvApiPlugin","lastEvent",params,function(data){
        __nativeLog__("success","上个event：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function updateInfo(bean,scene,trigger,action,eventparams,status) {
    var benstr = JSON.stringify(bean);
    var event = {
            sceneName: scene,
            triggerName:trigger,
            actionName:action
        };
    var eventstr = JSON.stringify(event);
    var params = {
        id: runingid,
        bean: benstr,
        event:eventstr,
        eventparams:eventparams,
        status:status
    };
    WVBridge("UIWvApiPlugin","updateInfo",params,function(data){
        __nativeLog__("success","上传信息：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function sendFatigue(bizCode,flowId,processorId){
    var bizCodestr = JSON.stringify(bizCode);
    var flowIdstr = JSON.stringify(flowId);
    var processorIdstr = JSON.stringify(processorId);

    var params = {
        bizCode: bizCodestr,
        flowId: flowIdstr,
        processorId: processorIdstr
    }

    WVBridge("MtopWVPlugin","send",{
            api:'mtop.taobao.widgetService.getJsonComponentRequireLogin',
            v:'2.0',
            param:{
                cid:'getFatigueRule:getFatigueRule',
                methodName:'execute',
                params:JSON.stringify(params)
            },
            ecode:0
        },(resJson) => {
            __nativeLog__("success",typeof resJson);
            var result = JSON.parse(resJson);
            if(result && result.data){
                __nativeLog__("success", JSON.stringify(result.data));

            }
        },(resJson) =>{
            __nativeLog__("fail",resJson);
            var result = JSON.parse(resJson);
                __nativeLog__("success", JSON.stringify(result.data));
        });
}

function getFatigueRule(bizCode,flowId,processorId) {
    var bizCodestr = JSON.stringify(bizCode);
    var flowIdstr = JSON.stringify(flowId);
    var processorIdstr = JSON.stringify(processorId);
    var params = {
    	api: 'mtop.taobao.widgetService.getJsonComponent',
    	v: '1.0',
    	post: '1',
    	methodName: 'execute',
        cid: 'getFatigueRule:getFatigueRule',
    	param: {
    		bizCode: bizCodestr,
    		flowId: flowIdstr,
    		processorId: processorIdstr
    	}
    };

    __nativeLog__("success", 'params:  ' + JSON.stringify(params));

    WVBridge('MtopWVPlugin', 'send', params, function(data) {
        isRunning=true;
        __nativeLog__("success", "疲劳上报完毕 data : " + data);
    }, function(e) {
        isRunning=false;
        __nativeLog__("success", "疲劳上报完毕 error : " + e);
    });
}


function closeCurrentPop(){
     if(isEmpty(showingPoplayerUrl)){
         closeTouch(showingPoplayerUrl);
      }
}

function closeCurrentTouch(){
    if(isEmpty(showingTouchUrl)){
        closeTouch(showingTouchUrl);
     }
}


function finishCurrent() {
    var params = {
        id: runingid
    };
    WVBridge("UIWvApiPlugin","finishCurrent",params,function(data){
        __nativeLog__("success","结束当前节点" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}



function showPopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showPoplayer",params,function(data){
        __nativeLog__("success","显示poplayer：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function showTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","showTouch",params,function(data){
        __nativeLog__("success","展示Touch：" + data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function saveOfferNum(num){
    __nativeLog__("success","存储num：" + num);
    var params = {
        File: spFileName,
        key: spKey,
        value: num
    };
    __nativeLog__("success","params" + params);
    WVBridge("FileWvApiPlugin", "write", params, function(data){
            __nativeLog__("success","写入成功：" + data);
        },function(err){
            __nativeLog__("fail",err);
        });
}

function readOfferNum(){
    var params = {
        File: spFileName,
        key: spKey
    };
    WVBridge("FileWvApiPlugin", "read", params, function(data){
        __nativeLog__("success","读取的data： " + data);
        var json = JSON.parse(data);
        offernum = parseInt(json.data.data);
        __nativeLog__("success","读取的num： " + offernum);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closePopLayer(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closePoplayer",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}

function closeTouch(url) {
    var params = {
        url: url,
        id: runingid
    };
    WVBridge("UIWvApiPlugin","closeTouch",params,function(data){
        __nativeLog__("success",data);
    },function(err){
        __nativeLog__("fail",err);
    });
}


function HashMap(){
    var length = 0;
    var obj = new Object();

    this.isEmpty = function(){
        return length == 0;
    };

    this.containsKey=function(key){
        return (key in obj);
    };

    this.containsValue=function(value){
        for(var key in obj){
            if(obj[key] == value){
                return true;
            }
        }
        return false;
    };

    this.put=function(key,value){
        if(!this.containsKey(key)){
            length++;
        }
        obj[key] = value;
    };

    this.get=function(key){
        return this.containsKey(key)?obj[key]:null;
    };

    this.remove=function(key){
        if(this.containsKey(key)&&(delete obj[key])){
            length--;
        }
    };

    this.values=function(){
        var _values= new Array();
        for(var key in obj){
            _values.push(obj[key]);
        }
        return _values;
    };

    this.keySet=function(){
        var _keys = new Array();
        for(var key in obj){
            _keys.push(key);
        }
        return _keys;
    };

    this.size = function(){
        return length;
    };

    this.clear = function(){
        length = 0;
        obj = new Object();
    };
}
